JUCE: AudioDeviceManager Class Reference

JUCE

Classes | Public Member Functions | List of all members
AudioDeviceManager Class Reference
juce_audio_devices » audio_io

Manages the state of some audio and midi i/o devices. More...

`#include <juce_AudioDeviceManager.h>`

Inheritance diagram for AudioDeviceManager:

## Classes
struct | AudioDeviceSetup
| This structure holds a set of properties describing the current audio setup. More...
struct | LevelMeter
| A simple reference-counted struct that holds a level-meter value that can be read using getCurrentLevel(). More...

## Public Member Functions
| AudioDeviceManager ()
| Creates a default AudioDeviceManager. More...
| ~AudioDeviceManager () override
| Destructor. More...
String | initialise (int numInputChannelsNeeded, int numOutputChannelsNeeded, const XmlElement *savedState, bool selectDefaultDeviceOnFailure, const String &preferredDefaultDeviceName=String(), const AudioDeviceSetup *preferredSetupOptions=nullptr)
| Opens a set of audio devices ready for use. More...
String | initialiseWithDefaultDevices (int numInputChannelsNeeded, int numOutputChannelsNeeded)
| Resets everything to a default device setup, clearing any stored settings. More...
std::unique_ptr< XmlElement > | createStateXml () const
| Returns some XML representing the current state of the manager. More...
AudioDeviceSetup | getAudioDeviceSetup () const
| Returns the current device properties that are in use. More...
void | getAudioDeviceSetup (AudioDeviceSetup &result) const
| Returns the current device properties that are in use. More...
String | setAudioDeviceSetup (const AudioDeviceSetup &newSetup, bool treatAsChosenDevice)
| Changes the current device or its settings. More...
AudioIODevice * | getCurrentAudioDevice () const noexcept
| Returns the currently-active audio device. More...
String | getCurrentAudioDeviceType () const
| Returns the type of audio device currently in use. More...
AudioIODeviceType * | getCurrentDeviceTypeObject () const
| Returns the currently active audio device type object. More...
void | setCurrentAudioDeviceType (const String &type, bool treatAsChosenDevice)
| Changes the class of audio device being used. More...
void | closeAudioDevice ()
| Closes the currently-open device. More...
void | restartLastAudioDevice ()
| Tries to reload the last audio device that was running. More...
void | addAudioCallback (AudioIODeviceCallback *newCallback)
| Registers an audio callback to be used. More...
void | removeAudioCallback (AudioIODeviceCallback *callback)
| Deregisters a previously added callback. More...
double | getCpuUsage () const
| Returns the average proportion of available CPU being spent inside the audio callbacks. More...
void | setMidiInputDeviceEnabled (const String &deviceIdentifier, bool enabled)
| Enables or disables a midi input device. More...
bool | isMidiInputDeviceEnabled (const String &deviceIdentifier) const
| Returns true if a given midi input device is being used. More...
void | addMidiInputDeviceCallback (const String &deviceIdentifier, MidiInputCallback *callback)
| Registers a listener for callbacks when midi events arrive from a midi input. More...
void | removeMidiInputDeviceCallback (const String &deviceIdentifier, MidiInputCallback *callback)
| Removes a listener that was previously registered with addMidiInputDeviceCallback(). More...
void | setDefaultMidiOutputDevice (const String &deviceIdentifier)
| Sets a midi output device to use as the default. More...
const String & | getDefaultMidiOutputIdentifier () const noexcept
| Returns the name of the default midi output. More...
MidiOutput * | getDefaultMidiOutput () const noexcept
| Returns the current default midi output device. More...
const OwnedArray< AudioIODeviceType > & | getAvailableDeviceTypes ()
| Returns a list of the types of device supported. More...
virtual void | createAudioDeviceTypes (OwnedArray< AudioIODeviceType > &types)
| Creates a list of available types. More...
void | addAudioDeviceType (std::unique_ptr< AudioIODeviceType > newDeviceType)
| Adds a new device type to the list of types. More...
void | removeAudioDeviceType (AudioIODeviceType *deviceTypeToRemove)
| Removes a previously added device type from the manager. More...
void | playTestSound ()
| Plays a beep through the current audio device. More...
LevelMeter::Ptr | getInputLevelGetter () noexcept
| Returns a reference-counted object that can be used to get the current input level. More...
LevelMeter::Ptr | getOutputLevelGetter () noexcept
| Returns a reference-counted object that can be used to get the current output level. More...
CriticalSection & | getAudioCallbackLock () noexcept
| Returns the a lock that can be used to synchronise access to the audio callback. More...
CriticalSection & | getMidiCallbackLock () noexcept
| Returns the a lock that can be used to synchronise access to the midi callback. More...
int | getXRunCount () const noexcept
| Returns the number of under- or over runs reported. More...
Public Member Functions inherited from ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster. More...
virtual | ~ChangeBroadcaster ()
| Destructor. More...
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster. More...
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list. More...
void | removeAllChangeListeners ()
| Removes all listeners from the list. More...
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners. More...
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners. More...
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately. More...

## Detailed Description

Manages the state of some audio and midi i/o devices.

This class keeps tracks of a currently-selected audio device, through with which it continuously streams data from an audio callback, as well as one or more midi inputs.

The idea is that your application will create one global instance of this object, and let it take care of creating and deleting specific types of audio devices internally. So when the device is changed, your callbacks will just keep running without having to worry about this.

The manager can save and reload all of its device settings as XML, which makes it very easy for you to save and reload the audio setup of your application.

And to make it easy to let the user change its settings, there's a component to do just that - the AudioDeviceSelectorComponent class, which contains a set of device selection/sample-rate/latency controls.

To use an AudioDeviceManager, create one, and use initialise() to set it up. Then call addAudioCallback() to register your audio callback with it, and use that to process your audio data.

The manager also acts as a handy hub for incoming midi messages, allowing a listener to register for messages from either a specific midi device, or from whatever the current default midi input device is. The listener then doesn't have to worry about re-registering with different midi devices if they are changed or deleted.

And yet another neat trick is that amount of CPU time being used is measured and available with the getCpuUsage() method.

The AudioDeviceManager is a ChangeBroadcaster, and will send a change message to listeners whenever one of its settings is changed.

See also
  AudioDeviceSelectorComponent, AudioIODevice, AudioIODeviceType

## Constructor & Destructor Documentation

## ◆ AudioDeviceManager()

AudioDeviceManager::AudioDeviceManager | ( |  | ) |

Creates a default AudioDeviceManager.

Initially no audio device will be selected. You should call the initialise() method and register an audio callback with setAudioCallback() before it'll be able to actually make any noise.

## ◆ ~AudioDeviceManager()

AudioDeviceManager::~AudioDeviceManager | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ initialise()

String AudioDeviceManager::initialise | ( | int | numInputChannelsNeeded,
|  | int | numOutputChannelsNeeded,
|  | const XmlElement * | savedState,
|  | bool | selectDefaultDeviceOnFailure,
|  | const String & | preferredDefaultDeviceName = `String()`,
|  | const AudioDeviceSetup * | preferredSetupOptions = `nullptr`
| ) |  |

Opens a set of audio devices ready for use.

This will attempt to open either a default audio device, or one that was previously saved as XML.

Parameters

  numInputChannelsNeeded | the maximum number of input channels your app would like to use (the actual number of channels opened may be less than the number requested)
  numOutputChannelsNeeded | the maximum number of output channels your app would like to use (the actual number of channels opened may be less than the number requested)
  savedState | either a previously-saved state that was produced by createStateXml(), or nullptr if you want the manager to choose the best device to open.
  selectDefaultDeviceOnFailure | if true, then if the device specified in the XML fails to open, then a default device will be used instead. If false, then on failure, no device is opened.
  preferredDefaultDeviceName | if this is not empty, and there's a device with this name, then that will be used as the default device (assuming that there wasn't one specified in the XML). The string can actually be a simple wildcard, containing "*" and "?" characters
  preferredSetupOptions | if this is non-null, the structure will be used as the set of preferred settings when opening the device. If you use this parameter, the preferredDefaultDeviceName field will be ignored. If you set the outputDeviceName or inputDeviceName data members of the AudioDeviceSetup to empty strings, then a default device will be used.

Returns
  an error message if anything went wrong, or an empty string if it worked ok.

Referenced by StandalonePluginHolder::reloadAudioDeviceState().

## ◆ initialiseWithDefaultDevices()

String AudioDeviceManager::initialiseWithDefaultDevices | ( | int | numInputChannelsNeeded,
|  | int | numOutputChannelsNeeded
| ) |  |

Resets everything to a default device setup, clearing any stored settings.

## ◆ createStateXml()

std::unique_ptr< XmlElement > AudioDeviceManager::createStateXml | ( |  | ) | const

Returns some XML representing the current state of the manager.

This stores the current device, its samplerate, block size, etc, and can be restored later with initialise().

Note that this can return a null pointer if no settings have been explicitly changed (i.e. if the device manager has just been left in its default state).

## ◆ getAudioDeviceSetup() [1/2]

AudioDeviceSetup AudioDeviceManager::getAudioDeviceSetup | ( |  | ) | const

Returns the current device properties that are in use.

See also
  setAudioDeviceSetup

## ◆ getAudioDeviceSetup() [2/2]

void AudioDeviceManager::getAudioDeviceSetup | ( | AudioDeviceSetup & | result | ) | const

Returns the current device properties that are in use.

This is an old method, kept around for compatibility, but you should prefer the new version which returns the result rather than taking an out-parameter.

See also
  getAudioDeviceSetup()

## ◆ setAudioDeviceSetup()

String AudioDeviceManager::setAudioDeviceSetup | ( | const AudioDeviceSetup & | newSetup,
|  | bool | treatAsChosenDevice
| ) |  |

Changes the current device or its settings.

If you want to change a device property, like the current sample rate or block size, you can call getAudioDeviceSetup() to retrieve the current settings, then tweak the appropriate fields in the AudioDeviceSetup structure, and pass it back into this method to apply the new settings.

Parameters

  newSetup | the settings that you'd like to use. If you don't need an input or output device, set the inputDeviceName or outputDeviceName data members respectively to empty strings. Note that this behaviour differs from the behaviour of initialise().
  treatAsChosenDevice | if this is true and if the device opens correctly, these new settings will be taken as having been explicitly chosen by the user, and the next time createStateXml() is called, these settings will be returned. If it's false, then the device is treated as a temporary or default device, and a call to createStateXml() will return either the last settings that were made with treatAsChosenDevice as true, or the last XML settings that were passed into initialise().

Returns
  an error message if anything went wrong, or an empty string if it worked ok.

See also
  getAudioDeviceSetup

## ◆ getCurrentAudioDevice()

AudioIODevice * AudioDeviceManager::getCurrentAudioDevice | ( |  | ) | const
| noexcept

Returns the currently-active audio device.

Referenced by StandalonePluginHolder::getIAAHostIcon(), StandalonePluginHolder::isInterAppAudioConnected(), StandalonePluginHolder::startPlaying(), and StandalonePluginHolder::switchToHostApplication().

## ◆ getCurrentAudioDeviceType()

String AudioDeviceManager::getCurrentAudioDeviceType | ( |  | ) | const

Returns the type of audio device currently in use.

See also
  setCurrentAudioDeviceType

## ◆ getCurrentDeviceTypeObject()

AudioIODeviceType * AudioDeviceManager::getCurrentDeviceTypeObject | ( |  | ) | const

Returns the currently active audio device type object.

Don't keep a copy of this pointer - it's owned by the device manager and could change at any time.

## ◆ setCurrentAudioDeviceType()

void AudioDeviceManager::setCurrentAudioDeviceType | ( | const String & | type,
|  | bool | treatAsChosenDevice
| ) |  |

Changes the class of audio device being used.

This switches between, e.g. ASIO and DirectSound. On the Mac you probably won't ever call this because there's only one type: CoreAudio.

For a list of types, see getAvailableDeviceTypes().

## ◆ closeAudioDevice()

void AudioDeviceManager::closeAudioDevice | ( |  | ) |

Closes the currently-open device.

You can call restartLastAudioDevice() later to reopen it in the same state that it was just in.

## ◆ restartLastAudioDevice()

void AudioDeviceManager::restartLastAudioDevice | ( |  | ) |

Tries to reload the last audio device that was running.

Note that this only reloads the last device that was running before closeAudioDevice() was called - it doesn't reload any kind of saved-state, and can only be called after a device has been opened with setAudioDeviceSetup().

If a device is already open, this call will do nothing.

## ◆ addAudioCallback()

void AudioDeviceManager::addAudioCallback | ( | AudioIODeviceCallback * | newCallback | ) |

Registers an audio callback to be used.

The manager will redirect callbacks from whatever audio device is currently in use to all registered callback objects. If more than one callback is active, they will all be given the same input data, and their outputs will be summed.

If necessary, this method will invoke audioDeviceAboutToStart() on the callback object before returning.

To remove a callback, use removeAudioCallback().

## ◆ removeAudioCallback()

void AudioDeviceManager::removeAudioCallback | ( | AudioIODeviceCallback * | callback | ) |

Deregisters a previously added callback.

If necessary, this method will invoke audioDeviceStopped() on the callback object before returning.

See also
  addAudioCallback

## ◆ getCpuUsage()

double AudioDeviceManager::getCpuUsage | ( |  | ) | const

Returns the average proportion of available CPU being spent inside the audio callbacks.

Returns
  A value between 0 and 1.0 to indicate the approximate proportion of CPU time spent in the callbacks.

## ◆ setMidiInputDeviceEnabled()

void AudioDeviceManager::setMidiInputDeviceEnabled | ( | const String & | deviceIdentifier,
|  | bool | enabled
| ) |  |

Enables or disables a midi input device.

The list of devices can be obtained with the MidiInput::getAvailableDevices() method.

Any incoming messages from enabled input devices will be forwarded on to all the listeners that have been registered with the addMidiInputDeviceCallback() method. They can either register for messages from a particular device, or from just the "default" midi input.

Routing the midi input via an AudioDeviceManager means that when a listener registers for the default midi input, this default device can be changed by the manager without the listeners having to know about it or re-register.

It also means that a listener can stay registered for a midi input that is disabled or not present, so that when the input is re-enabled, the listener will start receiving messages again.

See also
  addMidiInputDeviceCallback, isMidiInputDeviceEnabled

## ◆ isMidiInputDeviceEnabled()

bool AudioDeviceManager::isMidiInputDeviceEnabled | ( | const String & | deviceIdentifier | ) | const

Returns true if a given midi input device is being used.

See also
  setMidiInputDeviceEnabled

## ◆ addMidiInputDeviceCallback()

void AudioDeviceManager::addMidiInputDeviceCallback | ( | const String & | deviceIdentifier,
|  | MidiInputCallback * | callback
| ) |  |

Registers a listener for callbacks when midi events arrive from a midi input.

The device identifier can be empty to indicate that it wants to receive all incoming events from all the enabled MIDI inputs. Or it can be the identifier of one of the MIDI input devices if it just wants the events from that device. (see MidiInput::getAvailableDevices() for the list of devices).

Only devices which are enabled (see the setMidiInputDeviceEnabled() method) will have their events forwarded on to listeners.

## ◆ removeMidiInputDeviceCallback()

void AudioDeviceManager::removeMidiInputDeviceCallback | ( | const String & | deviceIdentifier,
|  | MidiInputCallback * | callback
| ) |  |

Removes a listener that was previously registered with addMidiInputDeviceCallback().

## ◆ setDefaultMidiOutputDevice()

void AudioDeviceManager::setDefaultMidiOutputDevice | ( | const String & | deviceIdentifier | ) |

Sets a midi output device to use as the default.

The list of devices can be obtained with the MidiOutput::getAvailableDevices() method.

The specified device will be opened automatically and can be retrieved with the getDefaultMidiOutput() method.

Pass in an empty string to deselect all devices. For the default device, you can use MidiOutput::getDefaultDevice().

See also
  getDefaultMidiOutput, getDefaultMidiOutputIdentifier

## ◆ getDefaultMidiOutputIdentifier()

const String & AudioDeviceManager::getDefaultMidiOutputIdentifier | ( |  | ) | const
| noexcept

Returns the name of the default midi output.

See also
  setDefaultMidiOutputDevice, getDefaultMidiOutput

## ◆ getDefaultMidiOutput()

MidiOutput * AudioDeviceManager::getDefaultMidiOutput | ( |  | ) | const
| noexcept

Returns the current default midi output device.

If no device has been selected, or the device can't be opened, this will return nullptr.

See also
  getDefaultMidiOutputIdentifier

## ◆ getAvailableDeviceTypes()

const OwnedArray< AudioIODeviceType > & AudioDeviceManager::getAvailableDeviceTypes | ( |  | ) |

Returns a list of the types of device supported.

## ◆ createAudioDeviceTypes()

virtual void AudioDeviceManager::createAudioDeviceTypes | ( | OwnedArray< AudioIODeviceType > & | types | ) |
| virtual

Creates a list of available types.

This will add a set of new AudioIODeviceType objects to the specified list, to represent each available types of device.

You can override this if your app needs to do something specific, like avoid using DirectSound devices, etc.

## ◆ addAudioDeviceType()

void AudioDeviceManager::addAudioDeviceType | ( | std::unique_ptr< AudioIODeviceType > | newDeviceType | ) |

Adds a new device type to the list of types.

## ◆ removeAudioDeviceType()

void AudioDeviceManager::removeAudioDeviceType | ( | AudioIODeviceType * | deviceTypeToRemove | ) |

Removes a previously added device type from the manager.

## ◆ playTestSound()

void AudioDeviceManager::playTestSound | ( |  | ) |

Plays a beep through the current audio device.

This is here to allow the audio setup UI panels to easily include a "test" button so that the user can check where the audio is coming from.

## ◆ getInputLevelGetter()

LevelMeter::Ptr AudioDeviceManager::getInputLevelGetter | ( |  | ) |
| noexcept

Returns a reference-counted object that can be used to get the current input level.

You need to store this object locally to ensure that the reference count is incremented and decremented properly. The current input level value can be read using getCurrentLevel().

## ◆ getOutputLevelGetter()

LevelMeter::Ptr AudioDeviceManager::getOutputLevelGetter | ( |  | ) |
| noexcept

Returns a reference-counted object that can be used to get the current output level.

You need to store this object locally to ensure that the reference count is incremented and decremented properly. The current output level value can be read using getCurrentLevel().

## ◆ getAudioCallbackLock()

CriticalSection & AudioDeviceManager::getAudioCallbackLock | ( |  | ) |
| noexcept

Returns the a lock that can be used to synchronise access to the audio callback.

Obviously while this is locked, you're blocking the audio thread from running, so it must only be used for very brief periods when absolutely necessary.

## ◆ getMidiCallbackLock()

CriticalSection & AudioDeviceManager::getMidiCallbackLock | ( |  | ) |
| noexcept

Returns the a lock that can be used to synchronise access to the midi callback.

Obviously while this is locked, you're blocking the midi system from running, so it must only be used for very brief periods when absolutely necessary.

## ◆ getXRunCount()

int AudioDeviceManager::getXRunCount | ( |  | ) | const
| noexcept

Returns the number of under- or over runs reported.

This method will use the underlying device's native getXRunCount if it supports it. Otherwise it will estimate the number of under-/overruns by measuring the time it spent in the audio callback.

The documentation for this class was generated from the following file:

- juce_AudioDeviceManager.h